include "acts_bridgecrane_reachable.gs"
include "acts_tools_script.gs"
  
//-----------------------------------------------------------------------------
// aCTS Bridgecrane V0.1 Central Script - acts_bridgecrane_script.gs
//-----------------------------------------------------------------------------
//   acts_bridgecrane           <-- acts_bridgecrane_script
// X acts_bridgecrane_script    <-- acts_bridgecrane_register
// X acts_bridgecrane_register  <-- acts_bridgecrane_reachable
//   acts_bridgecrane_reachable <-- acts_bridgecrane_moving
//   acts_bridgecrane_moving    <-- acts_bridgecrane_globals
//   acts_bridgecrane_globals   <-- acts_global_values
//   acts_global_values         <-- MapObject
//-----------------------------------------------------------------------------

class acts_bridgecrane_register isclass acts_bridgecrane_reachable
{
  //-------------------------------------------------------------------------
  // TBD: Outsource from acts_bridgecrane_script
  //-------------------------------------------------------------------------
};

class acts_bridgecrane_script isclass acts_bridgecrane_register
{
  //---------------------------------------------------------------------------
  // public void SetProperties(Soup soup) ....................... ca. line  23
  // public Soup GetProperties(void) ............................ ca. line  85
  // public void ObjectInitHandler(Message msg) ................. ca. line 100
  // public void WorldInitHandler(Message msg) .................. ca. line 132
  // public void DispatcherHandler(Message msg) ................. ca. line 183
  //---------------------------------------------------------------------------
  public void SetProperties(Soup soup)   // Callback method after Init method
  {
    inherited(soup);
    //-------------------------------------------------------------------------
    ObjectDataSoup.Copy(soup.GetNamedSoup("ObjectData"));
    LocationSoup.Copy(soup.GetNamedSoup("Location"));
    OrientationSoup.Copy(soup.GetNamedSoup("Orientation")) ;
    /*/-------------------------------------------------------------------------
    if (acts_debug) Interface.Log(Interface.GetTimeStamp()
                    + "CONTCRANE SETPROPERTIES SOUPS");
    if (acts_debug) actsTools.ShowSoup(ObjectDataSoup,"ObjDS=>");
    if (acts_debug) actsTools.ShowSoup(LocationSoup,"LocDS=>");
    if (acts_debug) actsTools.ShowSoup(OrientationSoup,"OriDS=>");
    //-------------------------------------------------------------------------*/
    isSetPropertiesMethodFinnished = true;
    PostMessage(me,"OBJECTINIT","SETPROPS_FINNISHED",0.0);
    return;
  }
  //---------------------------------------------------------------------------
  public Soup GetProperties(void)   // Callback method before closing session
  {
    Soup soup = inherited();
    //-------------------------------------------------------------------------
    soup.SetNamedSoup("ObjectData",ObjectDataSoup);
    soup.SetNamedSoup("Location",LocationSoup    );
    soup.SetNamedSoup("Orientation",OrientationSoup );
    //-------------------------------------------------------------------------
    if (acts_debug) Interface.Log(Interface.GetTimeStamp()
                    + "CONTCRANE GETPROPERTIES SOUPS");
    if (acts_debug) actsTools.ShowSoup(ObjectDataSoup,"ObjDS=>");
    if (acts_debug) actsTools.ShowSoup(LocationSoup,"LocDS=>");
    if (acts_debug) actsTools.ShowSoup(OrientationSoup,"OriDS=>");
    //-------------------------------------------------------------------------*/
    return soup;
  } 
  //---------------------------------------------------------------------------
  public void WorldInitHandler(Message msg)
  {
    //-------------------------------------------------------------------------
    if (acts_debug) Interface.Log(Interface.GetTimeStamp()
            + " [" + objectgoid.SerialiseToString() + "]"
            + " CONTCRANE GOT WORLDINIT MESSAGE ["
            + msg.major+"] ["+msg.minor+"]");
    //-------------------------------------------------------------------------*/
    // If one of the two methods (Init or SetProperties) isn't finished yet, 
    // post "World","ModuleInit" message a little bit later again.
    // So it is guaranteed that the Init and SetProperties methods are finished
    // as well as the "World","ModuleInit" message tells to be save using the 
    // World.GetCurrentModule method.
    //-------------------------------------------------------------------------
    if (!(isSetPropertiesMethodFinnished and isInitMethodFinnished))
    {
      PostMessage(me, "World", "ModuleInit", 0.2);
    }
    //-------------------------------------------------------------------------
    isWorldInitFinnished = true;
    PostMessage(me, "OBJECTINIT", "WORLD_INIT_FINNISHED", 0.0);
    //-------------------------------------------------------------------------
    return;
  }
  //---------------------------------------------------------------------------
  public void ObjectInitHandler(Message msg)
  {
    //-------------------------------------------------------------------------
    // Until the Trainz core send the "World","ModuleInit" was send it is not
    // guarented to decide with the World.GetCurrentModule method to be in the 
    // returned module! 
    //-------------------------------------------------------------------------
    if (acts_debug) Interface.Log(Interface.GetTimeStamp()
            + " [" + objectgoid.SerialiseToString() + "]"
            + " CONTCRANE GOT MESSAGE ["+msg.major+"] ["+msg.minor+"]");
    //-------------------------------------------------------------------------*/
    if (msg.dst==me and msg.major=="OBJECTINIT")
    {
      if (msg.minor=="INIT_FINNISHED")
      {
          //-------------------------------------------------------------------
          // Not used yet
          //-------------------------------------------------------------------
      }
      //-----------------------------------------------------------------------
      if (msg.minor=="SETPROPS_FINNISHED")
      {
        if (ObjectDataSoup.CountTags()==0)
        {
          //-------------------------------------------------------------------
          // LoadObjectDataInfos(ObjectDataSoup);
          //-------------------------------------------------------------------
          ObjectDataSoup.SetNamedTag("goid",objectgoid);
          ObjectDataSoup.SetNamedTag("type",objecttype);
          ObjectDataSoup.SetNamedTag("regID",-1);
          ObjectDataSoup.SetNamedTag("active",false);
          //ObjectDataSoup.SetNamedTag("requested",false);
          //ObjectDataSoup.SetNamedTag("hooked",false);
          ObjectDataSoup.SetNamedTag("cranebase_reacharea_x",cranebase_reacharea_x);
          ObjectDataSoup.SetNamedTag("cranebase_reacharea_y",cranebase_reacharea_y);
          ObjectDataSoup.SetNamedTag("cranebase_reacharea_z",cranebase_reacharea_z);
          ObjectDataSoup.SetNamedTag("cranebase_origin_inset_x",cranebase_origin_inset_x);
          ObjectDataSoup.SetNamedTag("cranebase_origin_inset_y",cranebase_origin_inset_y);
          ObjectDataSoup.SetNamedTag("cranebase_origin_inset_z",cranebase_origin_inset_z);
          ObjectDataSoup.SetNamedTag("max_container_count",max_container_count);
        }
        //---------------------------------------------------------------------
        if (acts_debug) Interface.Log(Interface.GetTimeStamp()
                    + " => SOUP 'ObjectDataSoup'");
        if (acts_debug) actsTools.ShowSoup(ObjectDataSoup,"=>");
        //---------------------------------------------------------------------*/
        if (LocationSoup.CountTags()==0)
        {
          //-------------------------------------------------------------------
          // LoadLocationDataInfos(LocationDataSoup);
          //-------------------------------------------------------------------
          WorldCoordinate WC = me.GetMapObjectPosition();
          LocationSoup.SetNamedTag("bbx",WC.baseboardX);
          LocationSoup.SetNamedTag("bby",WC.baseboardY);
          LocationSoup.SetNamedTag("px",WC.x);
          LocationSoup.SetNamedTag("py",WC.y);
          LocationSoup.SetNamedTag("pz",WC.z);
        }
        //---------------------------------------------------------------------
        if (OrientationSoup.CountTags()==0)
        {
          //-------------------------------------------------------------------
          // LoadOrientationDataInfos(OrientationDataSoup);
          //-------------------------------------------------------------------
          Orientation OR = me.GetMapObjectOrientation();
          LocationSoup.SetNamedTag("rx",OR.rx);
          LocationSoup.SetNamedTag("ry",OR.ry);
          LocationSoup.SetNamedTag("rz",OR.rz);
          LocationSoup.SetNamedTag("gx",OR.rx*180.0/Math.PI);
          LocationSoup.SetNamedTag("gy",OR.ry*180.0/Math.PI);
          LocationSoup.SetNamedTag("gz",OR.rz*180.0/Math.PI);
        }
        //---------------------------------------------------------------------
        // TBD: Adjust position and rotation to rounded values and handle
        //      the different pssibilities.
        //      (some methods see acts_tools_script.gs)
        //---------------------------------------------------------------------
        // Soup sp = actsTools.AutoAdjustMapObject(cast<MapObject>(me));
        // LocationSoup    = sp.GetNamedSoup("AdjustedLocationSoup");
        // OrientationSoup = sp.GetNamedSoup("AdjustedOrientationSoup");
        //---------------------------------------------------------------------
      }
      //-----------------------------------------------------------------------
      if (msg.minor=="WORLD_INIT_FINNISHED")
      {
        //---------------------------------------------------------------------
        // Do no module only, driver module only or surveyor module only
        // related initiations
        //---------------------------------------------------------------------
        if (World.GetCurrentModule() == World.DRIVER_MODULE)
        {
          //-------------------------------------------------------------------
          PostMessage(cast<GameObject>dispobj,
                               "REGISTER", "REGISTER_ME", ObjectDataSoup, 0.0);
          //-------------------------------------------------------------------
        }
        //---------------------------------------------------------------------
        if (World.GetCurrentModule() == World.SURVEYOR_MODULE)
        {
          //-------------------------------------------------------------------
          // Not used yet
          //-------------------------------------------------------------------
        }
        //---------------------------------------------------------------------
        if (World.GetCurrentModule() == World.NO_MODULE)
        {
          //-------------------------------------------------------------------
          // Not used yet
          //-------------------------------------------------------------------
        }
      }
    }
  }
  //---------------------------------------------------------------------------
  public void DispatcherHandler(Message msg)
  {
    if (msg.dst==me and msg.major=="DISPATCHER")
    {
      //-----------------------------------------------------------------------
      if (acts_debug) Interface.Log(Interface.GetTimeStamp()
              + " [" + objectgoid.SerialiseToString() + "] ["
              + " CONTCRANE GOT MESSAGE FROM DISPATCHER"
              + (cast<GameObject>msg.src).GetGameObjectID().SerialiseToString()
              + "] ["+msg.major+"] ["+msg.minor+"]");
      //-----------------------------------------------------------------------*/
      if (msg.minor=="OBJECTSOUP_UPDATED")
      {
        //---------------------------------------------------------------------
        // Update the own ObjectDataSoup
        //---------------------------------------------------------------------
        ObjectDataSoup.Copy(cast<Soup>msg.paramSoup);
        //---------------------------------------------------------------------*/
      }
      if (msg.minor=="OBJECTSOUP_INSERTED")
      {
        //---------------------------------------------------------------------
        // Update the own ObjectDataSoup
        //---------------------------------------------------------------------
        ObjectDataSoup.Copy(cast<Soup>msg.paramSoup);
        //---------------------------------------------------------------------*/
      }
      if (msg.minor=="OBJECTSOUP_APPENDED")
      {
        //---------------------------------------------------------------------
        // Update the own ObjectDataSoup
        //---------------------------------------------------------------------
        ObjectDataSoup.Copy(cast<Soup>msg.paramSoup);
        //---------------------------------------------------------------------*/
      }
    }
    //-------------------------------------------------------------------------
    return;
  }
};
