include "acts_global_values.gs"

//-----------------------------------------------------------------------------
// aCTS Container V0.1 Central Script - acts_container_script.gs
//-----------------------------------------------------------------------------
//   acts_container             <-- acts_container_script
//   acts_container_script      <-- acts_container_skinreplace
//   acts_container_skinreplace <-- acts_container_register
//   acts_container_register    <-- acts_container_globals
// X acts_container_globals     <-- acts_global_values
//   acts_global_values         <-- MapObject
//-----------------------------------------------------------------------------

class acts_container_globals isclass acts_global_values
{
  //---------------------------------------------------------------------------
  // AssetInstanceSoup {
  // X ObjectDataSoup { ... },    Only container, contstack, contcrane
  // X LocationSoup { ... },      Only container, contstack, contcrane
  // X OrientationSoup { ... },   Only container, contstack, contcrane
  // X SkinDataSoup { ... },      Only container
  // X ContentDataSoup { ... },   Only container
  //   DispatcherDataSoup { ... } Only dispatcher
  //   ContainerSoups  { ... }    Only dispatcher
  //   ContstackSoups  { ... }    Only dispatcher
  //   ContcraneSoups  { ... }    Only dispatcher
  // }
  //---------------------------------------------------------------------------
  // ObjectDataSoup { goid GameObjectID, type string,
  //                  length string, height string,  
  //                  stack goid, place int,           Only container
  //                  active bool, action string },
  // activ: true means the object sended a register message while session run
  //        All objects were set false while initialising dispatcher and if
  //        they stay false their entries will be deleted next initialising.
  // actions: ["APPENDED", "INSERTED", "UPDATED"];
  //---------------------------------------------------------------------------
  Soup ObjectDataSoup = Constructors.NewSoup();
  //---------------------------------------------------------------------------
  // LocationSoup { bbx int, bby int,               // WorlCoordinate parameter
  //                px float, py float, pz float }
  //---------------------------------------------------------------------------
  Soup LocationSoup = Constructors.NewSoup();
  //---------------------------------------------------------------------------
  // OrientationSoup { rx float, ry float, rz float,    // in rad 
  //                   gx float, gy float, gz float }   // in 1/10°
  //---------------------------------------------------------------------------
  Soup OrientationSoup = Constructors.NewSoup();
  //---------------------------------------------------------------------------
  GameObjectID objectgoid = me.GetGameObjectID();
  string       objecttype = "CONTAINER";
  string       contlength;
  string       contheight;
  Library      dispobj;
  GameObjectID dispgoid;
  //---------------------------------------------------------------------------
  Soup SkinDataSoup = Constructors.NewSoup();
  Soup ContentDataSoup = Constructors.NewSoup();
  //---------------------------------------------------------------------------
  // Container global variables - Skin Texture Replacement
  //---------------------------------------------------------------------------
  bool isAsyncTextureSearchFinnished = false;
  int skin = -1;   // ID-number of the current skin
  string skinDescription = "INITIAL SKIN-DESCRIPTION [Texture #"+skin+"]";
  Asset skins;     // Texture library asset object
  int textcount;
  //---------------------------------------------------------------------------
};
