include "acts_global_values.gs"

//-----------------------------------------------------------------------------
// aCTS Contstack V0.1 Central Script - acts_contstack_script.gs
//-----------------------------------------------------------------------------
//   acts_contstack             <-- acts_contstack_script
//   acts_contstack_script      <-- acts_contstack_register
//   acts_contstack_register    <-- acts_contstack_globals
// X acts_contstack_globals     <-- acts_global_values
//   acts_global_values         <-- MapObject
//-----------------------------------------------------------------------------

class acts_contstack_globals isclass acts_global_values
{
  //---------------------------------------------------------------------------
  // AssetInstanceSoup {
  // X ObjectDataSoup { ... },    Only container, contstack, contcrane
  // X LocationSoup { ... },      Only container, contstack, contcrane
  // X OrientationSoup { ... },   Only container, contstack, contcrane
  //   SkinDataSoup { ... },      Only container
  //   ContentDataSoup { ... },   Only container
  //   DispatcherDataSoup { ... } Only dispatcher
  //   ContainerSoups  { ... }    Only dispatcher
  //   ContstackSoups  { ... }    Only dispatcher
  //   ContcraneSoups  { ... }    Only dispatcher
  // }
  //---------------------------------------------------------------------------
  // ObjectDataSoup { goid GameObjectID, type string,
  //                  length string, height string,  
  //                  stack goid, place int,           Only container
  //                  active bool, action string },
  // activ: true means the object sended a register message while session run
  //        All objects were set false while initialising dispatcher and if
  //        they stay false their entries will be deleted next initialising.
  // actions: ["APPENDED", "INSERTED", "UPDATED"];
  //---------------------------------------------------------------------------
  // Container stack types:
  //   stackheight   "sc","hc"   pur height stack (standard or heigh cube)
  //                 "schc"      mixed height
  //   stacklength   "10ft","20ft","40ft","45ft","53ft"   pur length stack
  //   TBD: Mixed length stacks, possibly with mixed height.
  //        No deeper thoughts about this yet.
  //---------------------------------------------------------------------------
  Soup ObjectDataSoup = Constructors.NewSoup();
  //-------------------------------------------------------------------------
  // LocationSoup { bbx int, bby int,               // WorlCoordinate parameter
  //                px float, py float, pz float }
  //---------------------------------------------------------------------------
  Soup LocationSoup = Constructors.NewSoup();
  //---------------------------------------------------------------------------
  // OrientationSoup { rx float, ry float, rz float,    // in rad 
  //                   gx float, gy float, gz float }   // in 1/10°
  //---------------------------------------------------------------------------
  Soup OrientationSoup = Constructors.NewSoup();
  //---------------------------------------------------------------------------
  GameObjectID objectgoid = me.GetGameObjectID();
  string       objecttype = "CONTSTACK";
  string       stacklength;
  string       stackheight;   // Used for stack types
  Library      dispobj;
  GameObjectID dispgoid;
  //---------------------------------------------------------------------------
};
