include "acts_bridgecrane_script.gs"
  
//-----------------------------------------------------------------------------
// aCTS Bridgecrane V0.1 Central Script - acts_bridgecrane.gs
//-----------------------------------------------------------------------------
// X acts_bridgecrane           <-- acts_bridgecrane_script
//   acts_bridgecrane_script    <-- acts_bridgecrane_register
//   acts_bridgecrane_register  <-- acts_bridgecrane_reachable
//   acts_bridgecrane_reachable <-- acts_bridgecrane_moving
//   acts_bridgecrane_moving    <-- acts_bridgecrane_globals
//   acts_bridgecrane_globals   <-- acts_global_values
//   acts_global_values         <-- MapObject
//-----------------------------------------------------------------------------

class acts_bridgecrane isclass acts_bridgecrane_script
{
  // --------------------------------------------------------------------------
  // Mandatory INIT method
  // --------------------------------------------------------------------------
  public void Init(Asset asset)
  {
    inherited(asset);
    //-------------------------------------------------------------------------
    // Make shure that the right module is set for World.GetCurrentModle()
    // (see world.gs lines 939ff.) to start driver related initiations and
    // tell me, if my Init and SetProperties methods are finished.
    // Add handler for my tasks as dispatcher.
    //-------------------------------------------------------------------------
    AddHandler(me, "World", "ModuleInit", "WorldInitHandler");
    AddHandler(me, "OBJECTINIT", "", "ObjectInitHandler");
    AddHandler(me, "DISPATCHER", "", "DispatcherHandler");
    //-------------------------------------------------------------------------
    // It's nessecary to initalise the lib to force subscript preparing
    //-------------------------------------------------------------------------
    //World.GetLibrary(GetAsset().LookupKUIDTable("dummylibrary"));
    dispobj = World.GetLibrary(GetAsset().LookupKUIDTable("scriptinclude"));
    dispgoid = (cast<GameObject>dispobj).GetGameObjectID();
    //-------------------------------------------------------------------------
    // Load reacharea and other values from extension soup in my config.txt
    //-------------------------------------------------------------------------
    Soup csp = me.GetAsset().GetConfigSoupCached();
    csp = csp.GetNamedSoup("extensions");
    csp = csp.GetNamedSoup("reacharea-215489");
    cranebase_reacharea_x    = csp.GetNamedTagAsInt("cranebase_dimension_x"   );
    cranebase_reacharea_y    = csp.GetNamedTagAsInt("cranebase_dimension_y"   );
    cranebase_reacharea_z    = csp.GetNamedTagAsInt("cranebase_dimension_z"   );
    cranebase_origin_inset_x = csp.GetNamedTagAsInt("cranebase_origin_inset_x");
    cranebase_origin_inset_y = csp.GetNamedTagAsInt("cranebase_origin_inset_y");
    cranebase_origin_inset_z = csp.GetNamedTagAsInt("cranebase_origin_inset_z");
    max_container_count      = csp.GetNamedTagAsInt("max_container_count"     );
    //-------------------------------------------------------------------------
    moveCranePartsToZeroframe();
    //-------------------------------------------------------------------------
    isInitMethodFinnished = true;
    PostMessage(me,"OBJECTINIT","INIT_FINNISHED",0);   // Init method finnished
    //-------------------------------------------------------------------------
    return;
  }    
  // --------------------------------------------------------------------------
};
